#!/bin/ash
source ./static.conf
source ./dynamic.conf

LATEST_UPLOAD=$(/bin/cat latest_upload)
for measurement in measurements/*.json; do
	timestamp=$(basename $measurement .json)
	if [ "$timestamp" -gt "$LATEST_UPLOAD" ]; then
		day="$(($timestamp/86400))"
		sec="$(($timestamp-$day*86400))"

		cmd=$(jsonfilter -i $measurement -e 'ServerID=@.TestData.ServerID')
		eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Duration=@.TestData.Duration')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Manual=@.TestData.Manual')
                eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Download=@.ResultDownload.end.sum_received.bits_per_second')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Upload=@.ResultUpload.end.sum_received.bits_per_second')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'StartValue=@.RouterData.StartStatus')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'EndValueDown=@.RouterData.EndStatusDown')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'EndValueUp=@.RouterData.EndStatusUp')
		eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Valid=@.RouterData.Valid')
                eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'MidValue=@.RouterData.MidStatus')
	        eval $cmd

		# check for valid measurement                                                                                
		# download after - before should be less than 1.5 downloadResult                                   
		val="$(expr $StartValue - $EndValueDown)"                                                                       
		D="$(echo $Download | cut -d'.' -f1)"
		vla="$(expr $D \* 15 / 10)"                                                                 
		ValidA="-1";
		echo $vla                                                                                          
		if [ ! -z "$StartValue" ]; then
			if [ "$val" -lt "$vla" ]; then                                                                     
  				ValidA="0";
			fi                                                                                       
		fi                                                                                                 

		router=$(head -n 1 router.txt)
	
		data='{"TestData" : {"ServerID": "'$ServerID'", "Manual":"'$Manual'", "Duration":"'$Duration'"}, "Result" : {"Download": "'$Download'", "Upload":"'$Upload'"}, "RouterData" : {"ValidU":"'$Valid'", "ValidA":"'$ValidA'", "Routermodell": "'$router'", "StartValue": "'$StartValue'", "MidValue": "'$MidValue'", "EndValueDown": "'$EndValueDown'", "EndValueUp": "'$EndValueUp'"}}'
		echo $data
		list1="${list1}${Download},"
		list2="${list2}${Upload},"
	fi
done
	
rm /root/myapp/basic.html
cp /root/myapp/basic.html_template /root/myapp/basic.html
sed -i "s/INSERT_HERE1/$list1/" /root/myapp/basic.html
sed -i "s/INSERT_HERE2/$list2/" /root/myapp/basic.html
	
echo $(date)' : Create data script finished' >> /var/log/charlie.log;
