#!/bin/ash

# Need TR-064

CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
source $CWD/../static.conf


create_xml(){
        xml_data="<?xml version='1.0' encoding='utf-8'?><s:Envelope s:encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' xmlns:s='http://schemas.xmlsoap.org/soap/envelope/'><s:Body><u:$action xmlns:u='$service'></u:$action></s:Body></s:Envelope>"
}

create_xml_change_channel(){
        xml_data=$(echo -n "<?xml version='1.0' encoding='utf-8'?><s:Envelope s:encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' xmlns:s='http://schemas.xmlsoap.org/soap/envelope/'><s:Body><u:$action xmlns:u='$service'><$argument>$NEW_CHANNEL</$argument></u:$action></s:Body></s:Envelope>")
}

curl_request(){
        curl_output=$(curl -s -m 5 http://$ROUTER_IP:49000$control_url \
                        -H "Content-Type: text/xml; charset='utf-8'" \
                        -H "SoapAction:$service#$action" \
                        --data "$xml_data")
}

wget_request(){
        wget_output=$(wget --no-check-certificate \
        --http-user=dslf-config \
        --http-password=${ROUTER_PASSWORD} \
        --header="Content-Type: text/xml; charset='utf-8'" \
        --header="SoapAction:$service#$action" \
        --post-data="$xml_data" \
        --quiet \
        -O- \
        https://$ROUTER_IP:$PORT$control_url)
}

get_bssid(){
    service="urn:dslforum-org:service:WLANConfiguration:1"
    control_url="/upnp/control/wlanconfig1"
    action="GetBSSID"
    argument="NewBSSID"
    create_xml_change_channel
        wget_request
    bssid=$(echo $wget_output | awk -F"<$argument>" '{print $2}' | awk -F'<' '{print tolower($1)}')
    echo $bssid
}

get_security_port(){
        service="urn:dslforum-org:service:DeviceInfo:1"
        control_url="/upnp/control/deviceinfo"
        action="GetSecurityPort"
        create_xml
        curl_request
        PORT=$(echo $curl_output | awk -F'<NewSecurityPort>' '{print $2}' | awk -F'</NewSecurityPort>' '{print $1}')
}

get_security_port
get_bssid
