#!/bin/ash
CWD=$(dirname $0)

while getopts r:p:udc opt
do
	case $opt in
		r) ROUTER_IP=$OPTARG;;
		p) PASSWORD=$OPTARG;;
		u) OPTION="-u";;
		d) OPTION="-d";;
		c) OPTION="-c";;
	esac
done

upnp_enabled=$(ash $CWD/fb_wan_stats.sh -r $ROUTER_IP -t)
tr064_enabled=$(ash $CWD/../tr064/fritzbox_tr064.sh -r $ROUTER_IP -t)

#echo "ROUTER_IP: $ROUTER_IP"
#echo "PASSWORD:  $PASSWORD"
#echo "OPTION:    $OPTION"

if [ -n "$upnp_enabled" ]; then
	#echo "UPNP is enabled"
	ash "$CWD/fb_wan_stats.sh" -r $ROUTER_IP $OPTION
elif [ -n "$tr064_enabled" ]; then
	#echo "TR-064 is enabled"
	ash $CWD/../tr064/fritzbox_tr064.sh -r $ROUTER_IP -p $PASSWORD $OPTION
else
	echo "Please enable UPnP or TR-064."
	exit 1
fi

exit 0
