#!/bin/sh 

echo "Mosquitto listener is starting!"

source ./static.conf
source ./dynamic.conf

mosquitto_sub -h $SERVER -t "${UID}/${CID}" -p 8883 --capath /etc/ssl/certs -u $UID -P $PASSWORD | while read RAW_DATA;
do	 
  case "$RAW_DATA" in
    *"0$MESSAGE"*) 
	echo $(date)' : Execute measurement script - valid' >> /var/log/charlie.log;
	/bin/ash ./PerformMeasurement.sh MAN 0
	echo $(date)' : Measurement script executed' >> /var/log/charlie.log ;
	/bin/ash ./upload_data_from_charlie.sh 
	echo $(date)' : Upload after measurements' >> /var/log/charlie.log ;; 
    *"-1$MESSAGE"*)
	echo $(date)' : Execute measurement script - invalid' >> /var/log/charlie.log;
        /bin/ash ./PerformMeasurement.sh MAN 1 
        echo $(date)' : Measurement script executed' >> /var/log/charlie.log ;
	/bin/ash ./upload_data_from_charlie.sh
	echo $(date)' : Upload after measurements' >> /var/log/charlie.log ;;
    *"SETPWD"*)
	RPWD="$(echo $RAW_DATA | cut -d':' -f2)"
	echo $(date)' : Set password to PWD = '$RPWD >> /var/log/charlie.log; 
	/bin/sed -i 's/.*ROUTER_PASSWORD.*/ROUTER_PASSWORD="'$RPWD'"/' /root/static.conf ;;
    *"RITEUID"*)
	/bin/ash ./upload_ip.sh;;
    *"channel"*)
        chnr=$(echo $RAW_DATA | cut -f2 -d-);
        echo $(date)' : Attempting to set Channel to number '$chnr' in '$band' GHz band' >> /var/log/charlie.log;
        /bin/ash ./change_channel.sh "$chnr" ; 
        echo $(date)' : Channel is set to number '$chnr' in '$band' GHz band' >> /var/log/charlie.log ;;
    *) echo $(date)' : Message received, but not valid data:'$RAW_DATA >> /var/log/charlie.log ;;
  esac
done
