#!/bin/sh

FIREBASE_CONF="./firebase.conf"
MOSQUITTO_CONF="./mosquitto.conf"
SPEEDTEST_SCRIPT="PerformMeasurement.sh"
MEASUREMENTS_DIR="measurements/"
UPLOAD_SCRIPT="upload_data_from_charlie.sh"

echo "Did you do a reboot before running this script?"
logger -s "[Debug]: Start testing..."

source ./static.conf
source ./dynamic.conf

echo -e "\nCheck the following settings:"
echo "-----------------------------"
echo -e "\nFirebase Configuration:"
echo "My email is: $FB_EMAIL"
echo "My password is: $FB_PASSWORD"
echo "The user's ID is: $UID_USER"

echo -e "\nMosquitto Configuration:"
test "$TOPIC"="$UID_USER" || logger -s "[Error]: Mosquitto topic is not equal to UID!"
test "$USERNAME"="$UID_USER" || logger -s "[Error]: Mosquitto username is not equal to UID!"
test "$PASSWORD"="1234" || logger -s "[Error]: Mosquitto topic password is always 1234"

echo -e "\nTesting speedtest now..."
sh $SPEEDTEST_SCRIPT
meas_results=$(ls -t $MEASUREMENTS_DIR | head -1)
echo "Measurement results:"
cat $MEASUREMENTS_DIR$meas_results #TODO: Add parsing of results using jq

echo -e "\nTesting Firebase upload now..."
sh $UPLOAD_SCRIPT

echo -e "\nIf successful, delete now the test data from Firebase!"
read -rsn1 -p "Press any key when deleted data from Firebase."

echo -e "\n"
logger -s "[Info]: Finished test script"
