#!/bin/ash

CWD=$(dirname $0)

while getopts r:tp:du opt
do
	case $opt in
		r) ROUTER_IP=$OPTARG;;
		t) OPTION="-t";;
		p) PASSWORD=$OPTARG;;
		d) OPTION="download";;
		u) OPTION="upload";;
	esac
done

create_xml(){
	xml_data="<?xml version='1.0' encoding='utf-8'?><s:Envelope s:encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' xmlns:s='http://schemas.xmlsoap.org/soap/envelope/'><s:Body><u:$action xmlns:u='$service'></u:$action></s:Body></s:Envelope>"
}

curl_request(){
	curl_output=$(curl -s -m 5 http://$ROUTER_IP:49000$control_url -H "Content-Type: text/xml; charset='utf-8'" -H "SoapAction:$service#$action" -d "$xml_data")
}

curl_request_https(){
	curl_output=$(curl -s -k -m 5 --anyauth --user dslf-config:$PASSWORD https://$ROUTER_IP:$PORT$control_url -H "Content-Type: text/xml; charset='utf-8'" -H "SoapAction:$service#$action" -d "$xml_data")
}

service="urn:dslforum-org:service:DeviceInfo:1"
control_url="/upnp/control/deviceinfo"
action="GetSecurityPort"

create_xml
curl_request
PORT=$(echo $curl_output | awk -F'<NewSecurityPort>' '{print $2}' | awk -F'</NewSecurityPort>' '{print $1}')

if [ "$OPTION" == "-t" ]; then
	echo $PORT
	exit 0
elif [ -z "$PASSWORD" ]; then
	echo "Router password parameter is missing."
	exit 1
else
#service="urn:schemas-upnp-org:service:WANCommonInterfaceConfig:1"
#action="GetCommonLinkProperties"
#control_url="/igdupnp/control/WANCommonIFC1"
#
#create_xml
#curl_request_https
#maxDownloadRate=$(echo $curl_output | awk -F"<NewLayer1DownstreamMaxBitRate>" '{print $2}' | awk -F"</NewLayer1DownstreamMaxBitRate>" '{print $1}')
#maxUploadRate=$(echo $curl_output | awk -F"<NewLayer1UpstreamMaxBitRate>" '{print $2}' | awk -F"</NewLayer1UpstreamMaxBitRate>" '{print $1}')
#echo $curl_output
#echo "DSL Maximal Downloadrate: $maxDownloadRate"
#echo "DSL Maximal Uploadrate:   $maxUploadRate"

service="urn:dslforum-org:service:WANCommonInterfaceConfig:1"
control_url="/upnp/control/wancommonifconfig1"
action="GetTotalBytesSent"

create_xml
curl_request_https
totalBytesSent=$(echo $curl_output | awk -F"<NewTotalBytesSent>" '{print $2}' | awk -F"</NewTotalBytesSent>" '{print $1}')

action="GetTotalBytesReceived"
create_xml
curl_request_https
totalBytesReceived=$(echo $curl_output | awk -F"<NewTotalBytesReceived>" '{print $2}' | awk -F"</NewTotalBytesReceived>" '{print $1}')
fi

if [ "$OPTION" == "upload" ]; then
	echo "$totalBytesSent"
elif [ "$OPTION" == "download" ]; then
	echo "$totalBytesReceived"
else
	echo "Total Bytes Sent:     $totalBytesSent"
	echo "Total Bytes Received: $totalBytesReceived"
fi

exit 0
