#!/bin/sh

### Get current channel setting.
### ATTENTION!: Current active channel could be different with channel setting!

CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
source $CWD/../static.conf

if !( ./turris_test_password.sh ); then
    echo "Saved router password is incorrect."
    exit 1
fi

curl_req(){
        json_data='{"id": 1,"method": "login","params": ["root", "'"${ROUTER_PASSWORD}"'"]}'
        curl_data=$(curl -s -X POST "http://$ROUTER_IP/cgi-bin/luci/rpc/auth" --data "$json_data")
        erg=$(echo $curl_data | awk -F'"result":"' '{print $2}' | awk -F'"' '{print $1}')
        echo $erg
}

extract_result(){
    echo $1 | \
        awk -F'"result":"' '{print $2}' | \
        awk -F'"' '{print $1}'
}


TOKEN=$(curl_req)
link="http://$ROUTER_IP/cgi-bin/luci/rpc/uci?auth=$TOKEN"
hwmode0res=$(curl -s -X POST "$link" --data '{"id": "1","method": "get","params": ["wireless", "radio0", "hwmode"]}')
hwmode1res=$(curl -s -X POST "$link" --data '{"id": "1","method": "get","params": ["wireless", "radio1", "hwmode"]}')
hwmode0=$(extract_result "$hwmode0res")
hwmode1=$(extract_result "$hwmode1res")
disabled0res=$(curl -s -X POST "$link" --data '{"id": "1","method": "get","params": ["wireless", "radio0", "disabled"]}')
disabled1res=$(curl -s -X POST "$link" --data '{"id": "1","method": "get","params": ["wireless", "radio1", "disabled"]}')
disabled0=$(extract_result "$disabled0res")
disabled1=$(extract_result "$disabled1res")
if [ "$hwmode1" = "11g" ] && [ "$disabled1" = "0" ]; then
    radio="radio1"
else 
    if [ "$hwmode0" = "11g" ] && [ "$disabled0" = "0" ]; then
        radio="radio0"
    fi
fi

curl_data='{"id": "1","method": "get","params": ["wireless", "'"$radio"'", "channel"]}'
res=$(curl -s -X POST "$link" --data "$curl_data")
channel=$(extract_result "$res")
echo $channel
