#!/bin/ash
source ./static.conf
source ./dynamic.conf

./get_router_model.sh
	
RESP_TOKEN=$(/usr/bin/curl -s "$TOKEN_URL" \
	-H 'Content-Type: application/json' \
	--data-binary '{"email":"'$FB_EMAIL'","password":"'$FB_PASSWORD'","returnSecureToken":true}')
ID_TOKEN=$(echo $RESP_TOKEN | /usr/bin/jsonfilter -e '$.idToken')

if ( ./test_password.sh ); then
	statuscode=$(/usr/bin/curl -s -w "%{http_code}" -o /dev/null -X PUT -d "true" $FIREBASE_URL/users/$UID/charlie/charlies/$CID/routerPasswordConfirmed.json?auth=$ID_TOKEN);
else
	statuscode=$(/usr/bin/curl -s -w "%{http_code}" -o /dev/null -X PUT -d "false" $FIREBASE_URL/users/$UID/charlie/charlies/$CID/routerPasswordConfirmed.json?auth=$ID_TOKEN);   
fi

LATEST_UPLOAD=$(/bin/cat latest_upload)
for measurement in measurements/*.json; do
	timestamp=$(basename $measurement .json)
	if [ "$timestamp" -gt "$LATEST_UPLOAD" ]; then
		day="$(($timestamp/86400))"
		sec="$(($timestamp-$day*86400))"

		cmd=$(jsonfilter -i $measurement -e 'ServerID=@.TestData.ServerID')
		eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Duration=@.TestData.Duration')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Manual=@.TestData.Manual')
                eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Download=@.ResultDownload.end.sum_received.bits_per_second')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Upload=@.ResultUpload.end.sum_received.bits_per_second')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'StartValue=@.RouterData.StartStatus')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'EndValueDown=@.RouterData.EndStatusDown')
	        eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'EndValueUp=@.RouterData.EndStatusUp')
		eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'Valid=@.RouterData.Valid')
                eval $cmd

		cmd=$(jsonfilter -i $measurement -e 'MidValue=@.RouterData.MidStatus')
	        eval $cmd

		# check for valid measurement                                                                                
		# download after - before should be less than 1.5 downloadResult                                   
		val="$(expr $StartValue - $EndValueDown)"                                                                       
		D="$(echo $Download | cut -d'.' -f1)"
		vla="$(expr $D \* 15 / 10)"                                                                 
		ValidA="-1";
		echo $vla                                                                                          
		if [ ! -z "$StartValue" ]; then
			if [ "$val" -lt "$vla" ]; then                                                                     
  				ValidA="0";
			fi                                                                                       
		fi                                                                                                 

		router=$(head -n 1 router.txt)
	
		data='{"TestData" : {"ServerID": "'$ServerID'", "Manual":"'$Manual'", "Duration":"'$Duration'"}, "Result" : {"Download": "'$Download'", "Upload":"'$Upload'"}, "RouterData" : {"ValidU":"'$Valid'", "ValidA":"'$ValidA'", "Routermodell": "'$router'", "StartValue": "'$StartValue'", "MidValue": "'$MidValue'", "EndValueDown": "'$EndValueDown'", "EndValueUp": "'$EndValueUp'"}}'
		statuscode=$(/usr/bin/curl -s -w "%{http_code}" -o /dev/null -X PUT -d "$data" $FIREBASE_URL/users/$UID/measurements/$CID/$day/$sec.json?auth=$ID_TOKEN)
		echo $statuscode
		if [ "$statuscode" -eq  "200" ]; then
			echo "$timestamp" > latest_upload
		fi
	fi
done

# delete all json measurements uploaded minus 1 days
for measurement in measurements/*.json; do
	timestamp=$(basename $measurement .json)
	if [ "$timestamp" -lt "$(($LATEST_UPLOAD - $KEEP_MEASUREMENTS*86400))" ]; then
		rm $measurement 
	fi
done

echo $(date)' : Upload data script finished' >> /var/log/charlie.log;
